c***********************************************************************
c     drivers for routines funobj and funcon, to deal with
c     different objective and constraint functions
c***********************************************************************
      
c***********************************************************************
c     subroutine funobj: evaluates several objective functions,
c     depending on the ''nprob'' variable:                     
c     * nprob = 1001 => call fun11                            
c     * nprob = 1002 => call fun12                            
c     * nprob = 1003 => call funobj_htcoor
c     * nprob = 1004 => call funobj_kwan
c***********************************************************************
      subroutine funobj( mode, n, x, f, g, nstate, nprob, z, nwcore )
      
      implicit none
      double precision f, x(*), g(*), z(*)
      integer*4  mode, n, nstate, nprob, nwcore
      
      if (nprob .eq. 1001) then
         call fun11(n,x,f,g)
      else if (nprob .eq. 1002) then
         call fun12(n,x,f,g)
      else if (nprob .eq. 1003) then
         call funobj_htcoor(mode,n,x,f,g,nstate)
      else if (nprob .eq. 1004) then
         call funobj_kwan(n,x,f,g)
      end if
      
      end
      
c***********************************************************************
c     subroutine funcon may evaluate several constraint functions,
c     depending on the ''nprob'' variable:                     
c     * nprob = 1003 => call funcon_htcoor
c***********************************************************************
      subroutine funcon( mode, m, n, njac, x, f, g,
     $     nstate, nprob, z, nwcore )
      
      implicit  none
      include 'htcoor_f.h'
      double precision  x(*), f(*), g(*), z(*)
      integer*4 mode, m, n, njac, nstate, nprob, nwcore
      
      if (nprob .eq. 1003) then
         if (four_bytes_addresses) then
            call funcon_htcoor(mode,m,n,njac,x,f,g,nstate,
     $           %val(p_ijachd4),%val(p_ijacterm4),maxjac)
         else
             call funcon_htcoor(mode,m,n,njac,x,f,g,nstate,
     $           %val(p_ijachd8),%val(p_ijacterm8),maxjac)           
          end if
       end if
      end
      
c***********************************************************************
c     matmod function (not used)
c***********************************************************************
      subroutine matmod( ncycle, nprob, finish,
     $     m, n, nb, ne, nka, ns, nscl,
     $     a, ha, ka, bl, bu,
     $     ascale, hs, name1, name2,
     $     x, pi, rc, z, nwcore )
      end
      
