c***********************************************************************
c     minos objective function for htcoor
c     in minos5.5 derivatives are only required when mode=2
c***********************************************************************
      subroutine funobj_htcoor(mode,n,x,f,g,nstate)
      implicit none
      include 'htcoor_f.h'
c     arguments
      integer*4 mode,n,nstate
      real*8 x(n),f,g(n)
c     local variables
      integer*4 i,j,k,m,kov,ivs,ivf,mek,mak,iax,lom
      real*8 cvx,ves,vfi,pev,aux,xua,eextern,raux,raux1,raux2,raux3,
     $     raux4,eexternhd1,eexternpg,hd1,compra,sumterm,phdcobri
      integer*4 Entry_cola

C=    Initialize list of anti-cycling
C=
	if (nstate.eq.1) call Init_cola

c     clear objective function and gradients
c
      f=0.0d0
      do i=1,n
         g(i)=0.0d0
      end do
c
c     part termica referent a compra de combustibles
c
      do i= 1,nthrmarticles
         j= tipuscomb(i)
         if (j.gt.0) then
c     termica
            compra=0.0d0
            do k=1,nint
               compra=compra+x(c(k)+i-1)
               g(c(k)+i-1)=preu(j)
            end do
            f= f+preu(j)*(compra-apreciacio(j)*x(r(i)))
            g(r(i))= -preu(j)*apreciacio(j)
         else
c     contracte
            j= -j
            compra= 0.0d0
            do k=1,nint
               compra=compra+x(c(k)+i-1)
               g(c(k)+i-1)=cost_lin(j)+2*cost_quad(j)*x(c(k)+i-1)
            end do
            f= f + compra*(cost_lin(j)+cost_quad(j)*compra)
         end if
      end do
c     
c     part termica d'energia no subministrada i comprada a l'exterior
c    
c**
c**      preuext= 1.0e+5
c**
      do i= 1,nint
         hd1= x(hn(i))
         sumterm= 0.0d0
         do j= 0,nterm-1
            sumterm= sumterm+x(pg(i)+j)
         end do
         phdcobri= x(iphd(i))
         raux= hd1-e0b(i)
c**         raux1= sumpmaxterm(i)-sumterm + 0.0001d0
c**         raux2= phdmax-hd1/tbase(i)-phdcobri + 0.0001d0
         raux1= sumpmaxterm(i)-sumterm 
         raux2= phdmax-hd1/tbase(i)-phdcobri 
         raux3= raux1+raux2
         raux4= 2.0d0*e0a(i)*raux3
c**         if (dabs(raux).lt.1.0d-6) stop '1'
         eextern= (e0a(i)*raux3*raux3)/raux + e0c(i)
c**         if (dabs(raux*raux).lt.1.0d-6) stop '2'
         eexternhd1= (-raux4/tbase(i)*raux-(e0a(i)*raux3*raux3))/
     $        (raux*raux)
         eexternpg= -raux4/raux
         f= f+preuext*eextern      
         g(hn(i))= preuext*eexternhd1
         do j= 0,nterm-1
            g(pg(i)+j)= preuext*eexternpg
         end do
         g(iphd(i))= preuext*eexternpg
      end do
c     
c     part hidraulica amb penalitzacions per vessaments
c     
      kov= 0
      do  i= 1,nint
         do j= 1,nvv
            cvx=cxv(j)
            kov=kov+1
            ivs=ivv(kov)
            ivf=mfv(kov)
            ves=0.0d0
            vfi=von(i*neb+iov(j))
            pev=0.0d0
            do k=1,nat
               mek=(k-1)*neb
               mak=(k-1)*nax
               if (ivf.lt.0) then 
                  iax=-ivf+mek
                  vfi=rfl(iax)
               else if (ivf.gt.0) then
                  vfi=vfi+ x (ivf+mak)
               else 
                  stop 'mfv(.)=0'
               end if
c     localitzacio del vessament
               ves=ves+ x (ivs+mak)
               pev=pev+(cvx-vfi)*ves
c     no cal guardar derivades perque no depenen del total
               aux=pvi*(cvx-vfi)
               xua=pvi*ves
               do m= 1,k
                  lom=(m-1)*nax+ivs
                  g(lom)=g(lom)+aux
                  if (ivf.gt.0) then 
                     lom=(m-1)*nax+ivf
                     g(lom)=g(lom)-xua
                  end if
               end do
            end do
            f=f+pvi*pev
         end do
      end do
c      if (nstate.eq.2) then
c         call escriu_info_optim(n,x,f,z,nwcore)
c      endif 

C=	Add this result to the list 
C=	If "Entry_cola = 0" stop iterations
!						-- Uncomment if you want
!	if (Entry_cola(f).eq.0) mode = -1
!						-- to do that
      end  !fi funcio objectiu


c***********************************************************************
c     minos nonlinear constraints function
c     in minos5.5 derivatives are only required when mode=2
c***********************************************************************
      subroutine funcon_htcoor(mode,m,n,njac,x,f,g,nstate,ijachd,
     $     ijacterm,ne_njac)
      implicit none
      include 'htcoor_f.h'
c     arguments
      integer*4 mode,m,n,njac,nstate,ne_njac,ijachd(ne_njac),
     $     ijacterm(ne_njac)
      real*8 x(n),f(m),g(njac)
c     local variables
      integer*4 i,j,k,l,koc,jac,ivi,ivf,iwi,iwf,meo,med,iax,mek,mak,
     $     iaux,cthdi,ij,rowpg,rowcob,colg,colhd,ijt,arbo
      real*8 coe,olm,oqu,oqt,oqd,ocq,occu,dlm,dqu,dqt,dqd,dcq,
     $     dccu,alt,vfi,
     $     wfi,win,vin,cab,vif,dfi,wif,efi,www,ghi,cbb,ala,vvv,
     $     vt1,vt2,vt5,vt9,wt1,wt2,wt5,wt9,
     $     abansghi,abansdgdd,dgdd,abansdgdvio,dgdvio,hm3_m3s,
     $     r_ms, efic, d_efic_h, d_efic_d, d_vol, cons, d_cons,
     $     abansdgdvfo,dgdvfo,abansdgdvid,dgdvid,
     $     abansdgdvfd,dgdvfd,
     $     gen,cpe,parcialgen,parcialhd,parcialpg,
     $     abanscpe,abanspgen,abansphd,abansppg,
     $     sumterm,phdcobri,hd(MAXNAT)

c     ***** PART HIDRAULICA MULTIARTICLE *****
c     En aquesta part es calculen les expressions que ens donen
c     la generacio hidraulica --per cada article i interval-- en
c     funcio de les descarregues, volums inicials i volums finals
c     
c     inicialitzem algunes coses
c     conversio de Hm3 de cabal * 1m. salt d'aigua a Mwh/escal_energia

      coe=2.725d0/escal_energia
!!!      coe = 1.d0/escal_energia			!! [JAG 11/3/98]
      do i= 1,nint*nat
         f(i)= 0.0d0
      end do
      do i= 1,elemblochd*nat*(nat+1)/2
         g(i)= 0.0d0
      end do
c     
      ij= 0
      koc=0
      do i= 1,nint
         Hm3_m3s = 277.777777778/(nhores(i)*escal_hores)
         do j= 1,ncc
!!!            cgb=coe*ren(j)
c     
            koc=koc+1
            jac=jca(koc)
            ivi=ivo(koc)
            ivf=lvo(koc)
            iwi=ivd(koc)
            iwf=lvd(koc)
c     emb. orig., emb. dest.
            meo=jeo(j)
            med=jed(j)
c     
	    if (jll(j) .lt.0) then
                olm=elm(meo)
                oqu=cvq(meo)
                oqt=eqt(meo)
                oqd=eqd(meo)
                ocq=ecq(meo)
                occu=ecua(meo)
c     
                if (iwf.ne.0) then
                   dlm=elm(med)
                   dqu=cvq(med)
                   dqt=eqt(med)
                   dqd=eqd(med)
                   dcq=ecq(med)
                   dccu=ecua(med)
                end if
	    else		!!!  P U M P I N G
		arbo = jabom(j)
		olm = salto(arbo)*0.5
		oqu = salto(arbo+1)
		oqt = oqu/3.0
		oqd = 2.0*oqt
		ocq = salto(arbo+2)*0.25
		occu = 0.0
		dlm = salto(arbo+3)*0.5
		dqu = salto(arbo+4)
		dqt = dqu/3.0
		dqd = 2.0*dqt
		dcq = salto(arbo+5)*0.25
		dccu = 0.0
	    end if

            alt=snq(j)
c
            iax=i*neb+meo
            vfi=von(iax)
            vin=von(iax-neb)
            iax=i*neb+med
            wfi=von(iax)
            if (iax-neb .gt. 0) win=von(iax-neb)
            cab=can(koc)
c     
            abansghi= 0.0d0
            abansdgdd= 0.0d0
            abansdgdvio= 0.0d0
            abansdgdvid= 0.0d0
            abansdgdvfo= 0.0d0
            abansdgdvfd= 0.0d0
            iaux= i  !posicio de restriccio per primer article
            do k= 1,nat
c     
               mek=(k-1)*neb
               mak=(k-1)*nax
c     
               cab=cab+ x (jac+mak)
!!!               cbb=cgb*cab
               cbb=cab		!! [JAG 4/9/98]
c     
               if (ivi.lt.0) then
                  iax=-ivi+mek
                  vin=rin(iax)
               else if (ivi.gt.0) then
                  vin=vin+ x (ivi+mak)
               else
                  stop 'ivo(.)= 0'
               end if
c     
               if (iwi.lt.0) then
                  iax=-iwi+mek
                  win=rin(iax)
               else if (iwi.gt.0) then
                  win=win+ x (iwi+mak)
               end if
c     
               if (ivf.lt.0) then
                  iax=-ivf+mek
                  vfi=rfl(iax)
               else if (ivf.gt.0) then
                  vfi=vfi+ x (ivf+mak)
               else 
                  stop 'ivo(.)= 0'
               end if
c     
               vif=vin+vfi
               dfi=vfi-vin
               vt1 = vin*vin
               vt2 = vt1*vt1
               vt5 = vfi*vfi
               vt9 = vt5*vt5
               vvv=vt1+vt5
c     
               ala=alt+olm*vif+oqt*dfi*dfi+oqu*vin*vfi+ocq*vvv*vif
     $              + occu*(vt2 + vt1*vt5 + vt9 + vvv*vin*vfi)
c
               if (iwf.ne.0) then
                  if (iwf.lt.0) then
                     iax=-iwf+mek
                     wfi=rfl(iax)
                  else 
                     wfi=wfi+ x (iwf+mak)
                  end if
                  wif=win+wfi
                  efi=wfi-win
                  wt1 = win*win
                  wt2 = wt1*wt1
                  wt5 = wfi*wfi
                  wt9 = wt5*wt5
                  www=wt1+wt5
                  ala=ala-(dlm*wif+dqt*efi*efi+dqu*win*wfi+dcq*www*wif)
     $                 - dccu*(wt2 + wt1*wt5 + wt9 + www*win*wfi) 
               end if
c     posem valors a f(.)

               if (jll(j).lt.0) then !! parte de la generacion !!
c............
c     la generacion se calcula como: 
c     efic(h, r') * h * r * 2.725
c..... - - - - - - - - - - - - - - - - - - - -
                  r_ms = cbb*hm3_m3s
                  efic = ehe0(j) + r_ms* (ehe1(j) + r_ms*ehe4(j)) +
     $                 ala* (ehe2(j) + r_ms*ehe3(j) + ala*ehe5(j))

                  d_efic_h = 2*ehe5(j)*ala + ehe3(j)*r_ms + ehe2(j)
                  d_efic_d = hm3_m3s*(2*ehe4(j)*r_ms + ehe3(j)*ala 
     $                 + ehe1(j))
                  ghi=coe*cbb*efic*ala

c%'''''''''''''''''''''' derivades de la generacio
c     
                  dgdd = (d_efic_d*cbb+efic)*ala*coe !respect la descarga
                  d_vol = coe*cbb*(d_efic_h*ala+efic)
c     %===========================================
               else             !! parte de los bombeos
c.........
c     la funcion de bombeo es cons(h) * r
c.........
                  cons = ehe0(j) + ala*(ehe1(j) + ala*(ehe2(j) + 
     $                 ala*(ehe3(j) + ala*ehe4(j))))
                  d_cons = ehe1(j) + ala*(2*ehe2(j) + ala*(3*ehe3(j)
     $                 + 4*ala*ehe4(j)))
                  ghi = -cons*cbb
c     %'''''''''''''''''''''' derivadas del bombeo
     
                  dgdd= -cons   ! respecto la descarga
                  d_vol = -cbb*d_cons
               end if
               f(iaux)= f(iaux) + ghi-abansghi
               iaux= iaux+nint!posicio de restriccio per seguent article
               abansghi= ghi
c
c     calculem derivades (posem cada derivada a tots els llocs on 
c     tingui afectacio: si estem a article k --sumatori de volums i
c     descarregues fins article k-- hi ha afectacio per les descarregues
c     i volums de 1 fins k en la generacio k; aixi mateix tambe 
c     hem d'afectar aquests termes pels anteriors --fins article k-1--
c     donat que cada generacio es calcula considerant el generat amb 
c     articles 1..k i restant-li el generat amb articles 1..k-1--)
c     
c     derivada respecte la Descarrega (calculada abans a dgdd)
               do l= 1,k-1
                  ij= ij+1
                  g(ijachd(ij))= g(ijachd(ij))+dgdd-abansdgdd
               end do
               ij= ij+1
               g(ijachd(ij))= g(ijachd(ij))+dgdd
               abansdgdd= dgdd
c     derivada respecte Volum-Inicial-Origen
               if (ivi.gt.0) then
                  dgdvio= d_vol*(olm-oqd*dfi+oqu*vfi
     $                 +ocq*(vvv+(vin+vin)*vif)
     $                 +occu*(vin*(2.*vt5+vin*(vin+3.*vif))+vt5*vfi))
                  do l= 1,k-1
                     ij= ij+1
                     g(ijachd(ij))= g(ijachd(ij))+dgdvio-abansdgdvio
                  end do
                  ij= ij+1
                  g(ijachd(ij))= g(ijachd(ij))+dgdvio
                  abansdgdvio= dgdvio
               end if
c     derivada respecte Volum-Inicial-Desti
               if (iwi.gt.0) then
                  dgdvid=-d_vol*(dlm-dqd*efi+dqu*wfi
     $                 +dcq*(www+(win+win)*wif)
     $                 +dccu*(win*(2.*wt5+win*(win+3.*wif))+wt5*wfi))
                  do l= 1,k-1
                     ij= ij+1
                     g(ijachd(ij))= g(ijachd(ij))+dgdvid-abansdgdvid
                  end do
                  ij= ij+1
                  g(ijachd(ij))= g(ijachd(ij))+dgdvid
                  abansdgdvid= dgdvid
               end if
c     derivada respecte Volum-Final-Origen
               if (ivf.gt.0) then
                  dgdvfo= d_vol*(olm+oqd*dfi+oqu*vin
     $                 +ocq*(vvv+(vfi+vfi)*vif)
     $                 +occu*(vfi*(2.*vt1+vfi*(vfi+3.*vif))+vt1*vin))
                  do l= 1,k-1
                     ij= ij+1
                     g(ijachd(ij))= g(ijachd(ij))+dgdvfo-abansdgdvfo
                  end do
                  ij= ij+1
                  g(ijachd(ij))= g(ijachd(ij))+dgdvfo
                  abansdgdvfo= dgdvfo
               end if
c     derivada respecte Volum-Final-Desti
               if (iwf.gt.0) then
                  dgdvfd=-d_vol*(dlm+dqd*efi+dqu*win
     $                 +dcq*(www+(wfi+wfi)*wif)
     $                 +dccu*(wfi*(2.*wt1+wfi*(wfi+3.*wif))+wt1*win))
                  do l= 1,k-1
                     ij= ij+1
                     g(ijachd(ij))= g(ijachd(ij))+dgdvfd-abansdgdvfd
                  end do
                  ij= ij+1
                  g(ijachd(ij))= g(ijachd(ij))+dgdvfd
                  abansdgdvfd= dgdvfd
               end if
c     fi de derivades de part hidraulica
            end do
         end do
      end do 
c
c     
c     ***** PART TERMICA *****      
c     En aquest part es treballa amb la part termica usant la
c     generacio hidraulica pero amb les variables de canvi de
c     variable per emmagatzemar la generacio hidraulica.
c
      rowpg= nat*nint
      rowcob= rowpg+nterm*nint
      ijt= 0
      do i= 1,nint
c     trobem alcada de les termiques a l'interval i i valors phd
         sumterm= 0.0d0
         do j= 0,nterm-1
            sumterm= sumterm+x(pg(i)+j)
         end do
         phdcobri= x(iphd(i))
c     Afegim les variables de canvi de variable a les restriccions 
c     de canvi de variable. no cal posar el jacobia perque ja 
c     l'hem posat directament a l'apartat mps per ser constant a -1.0
         cthdi= hn(i)
         iaux= i  !posicio restriccio canvi variable primer article
         do k= 1,nat
            hd(k)= x(cthdi)
            cthdi= cthdi+1
            f(iaux)= f(iaux) - hd(k)
            iaux= iaux+nint !posicio restr. canvi var. next article
         end do
c     ara passem a la part de les corbes de Bezier
         call calcular_pbezier(i,hd,sumterm,phdcobri)
         gen= 0.0d0
         colg= t(i)
         colhd= hl(i)
c     nterm restriccions de potencia de cada termica (interval i)
         do j= 1,nterm
c     calculem generacio abans de termica j
            if (j.gt.1) then
               gen= gen+x(colhd)
               colhd= colhd+1
            end if
            call eval_cpe(gen,abanscpe,abanspgen,abansphd,abansppg)
c     calculem generacio fins termica j
            do k= 1,nartterm(j)
               gen= gen+x(colg)
               colg= colg+1
            end do
            call eval_cpe(gen,cpe,parcialgen,parcialhd,parcialpg)
c     f(.) -valor restriccio-
            rowpg= rowpg+1
            f(rowpg)= cpe-abanscpe-x(pg(i)+j-1)
c     g(.) -valor jacobia-
            ijt= ijt+1
            g(ijacterm(ijt))= parcialhd-abansphd
            do l= 1,j-1
               ijt= ijt+1
              g(ijacterm(ijt))= parcialgen-abanspgen
            end do
            do l= 1,j
               do k= 1,nartterm(l)
                  ijt= ijt+1
                  if (l.eq.j) then
                     g(ijacterm(ijt))= parcialgen
                  else
                     g(ijacterm(ijt))= parcialgen-abanspgen
                  end if
               end do
            end do
            do l= 1,nterm
               ijt= ijt+1
               if (l.eq.j) then
                  g(ijacterm(ijt))= parcialpg-abansppg-1.0d0
               else
                  g(ijacterm(ijt))= parcialpg-abansppg
               end if
            end do
            ijt= ijt+1
            g(ijacterm(ijt))= parcialpg-abansppg
         end do
c     restriccio de cobriment (interval i). posem darrera hidraulica
         gen= gen+x(colhd)
         call eval_cpe(gen,cpe,parcialgen,parcialhd,parcialpg)
c     f(.) -valor restriccio-
         rowcob= rowcob+1
         f(rowcob)= cpe-phdcobri-sumterm
c     g(.) -valor jacobia-
         ijt= ijt+1
         g(ijacterm(ijt))= parcialhd
         do j= 1,nterm
            ijt= ijt+1
            g(ijacterm(ijt))= parcialgen
         end do
         do j= 1,nterm
            do k= 1,nartterm(j)
               ijt= ijt+1
               g(ijacterm(ijt))= parcialgen
            end do
         end do
         do j= 1,nterm
            ijt= ijt+1
            g(ijacterm(ijt))= parcialpg-1.0d0
         end do
         ijt= ijt+1
         g(ijacterm(ijt))= parcialpg-1.0d0
      end do
      
      end
      

c***********************************************************************
c     computing bezier curves
c***********************************************************************
      subroutine calcular_pbezier(i,hd,sumterm,phdcobri)
      implicit none
      include 'htcoor_f.h'
c     predefined constants for Bezier curves
      real*8 alfa1,alfa2
      parameter(alfa1= 0.8)
      parameter(alfa2= 0.2)
c     arguments
      integer*4 i
      real*8 hd(nat),sumterm,phdcobri
c     local variables
      real*8 etall,etallhd,etallpg,
     $     ptall,ptallhd,ptallpg,
     $     eextern,eexternhd,eexternpg,
     $     textern,texternhd,texternpg,
     $     raux,raux1,raux2,raux3,raux4

c
c     calculem eextern,eexternhd,eexternpg
      raux= hd(1)-e0b(i)
      raux1= sumpmaxterm(i)-sumterm 
      raux2= phdmax-hd(1)/tbase(i)-phdcobri 
      raux3= raux1+raux2
      raux4= 2.0d0*e0a(i)*raux3
c**      if (dabs(raux).lt.1.0d-6) stop '3'
      eextern= (e0a(i)*raux3*raux3)/raux + e0c(i)
c**      if (dabs(raux*raux).lt.1.0d-6) stop '4'
      eexternhd= (-raux4/tbase(i)*raux-(e0a(i)*raux3*raux3))/(raux*raux)
      eexternpg= -raux4/raux
c
c     calculem textern,texternhd,texternpg
      raux= hd(1)-t0b(i)
      raux1= sumpmaxterm(i)-sumterm 
      raux2= phdmax-hd(1)/tbase(i)-phdcobri 
      raux3= raux1+raux2
      raux4= 2.0d0*t0a(i)*raux3
c**      if (dabs(raux).lt.1.0d-6) stop '5'
      textern= (t0a(i)*raux3*raux3)/raux + t0c(i)
c**      if (dabs(raux).lt.1.0d-6) stop '6'
      texternhd= (-raux4/tbase(i)*raux-(t0a(i)*raux3*raux3))/(raux*raux)
      texternpg= -raux4/raux
c
c
c     calculem punts de la corba de Bezier 
c     
c     e(1) i p(1)
c
      p(1)= pmin(i)
      e(1)= tbase(i)*pmin(i)
      ehd(1)= 0.0d0
      phd(1)= 0.0d0
      epg(1)= 0.0d0
      ppg(1)= 0.0d0
c
c     e(4) i p(4)
c
      p(4)= sumterm+phdcobri
      e(4)= energia(i)-hd(1)-eextern
      phd(4)= 0.0d0
      ehd(4)= -1.0d0-eexternhd
      ppg(4)= 1.0d0
      epg(4)= -eexternpg
c
c     etall i ptall
c
      raux= textern-tbase(i)
      if (dabs(raux).lt.1.0d-6) then
         write(*,*) textern,tbase(i)
         write(*,*) hd(1)
         write(*,*) t0a(i),t0b(i),t0c(i)
         write(*,*) sumpmaxterm(i)-sumterm
         write(*,*) phdmax-hd(1)/tbase(i)-phdcobri
c**         stop '7'
      end if
      ptall= (textern*p(4)-e(4))/raux
      etall= tbase(i)*ptall
      ptallhd= (texternhd*p(4)+textern*phd(4)-ehd(4))*raux
c**      if (dabs(raux*raux).lt.1.0d-6) stop '8'
      ptallhd= (ptallhd-(textern*p(4)-e(4))*texternhd)/(raux*raux)
      etallhd= tbase(i)*ptallhd
      ptallpg= (texternpg*p(4)+textern*ppg(4)-epg(4))*raux
      ptallpg= (ptallpg-(textern*p(4)-e(4))*texternpg)/(raux*raux)
      etallpg=  tbase(i)*ptallpg
c
c     e(2) i p(2)
c
      e(2)= (1.0d0-alfa1)*e(1)+alfa1*etall
      p(2)= e(2)/tbase(i)
      ehd(2)= alfa1*etallhd
      phd(2)= ehd(2)/tbase(i)
      epg(2)= alfa1*etallpg
      ppg(2)= epg(2)/tbase(i)
c
c     e(3) i p(3)
c 
      e(3)= (1.0d0-alfa2)*etall+alfa2*e(4)
      p(3)= (1.0d0-alfa2)*ptall+alfa2*p(4)
      ehd(3)= (1.0d0-alfa2)*etallhd+alfa2*ehd(4)
      phd(3)= (1.0d0-alfa2)*ptallhd+alfa2*phd(4)
      epg(3)= (1.0d0-alfa2)*etallpg+alfa2*epg(4)
      ppg(3)= (1.0d0-alfa2)*ptallpg+alfa2*ppg(4)      
c    
c     ara calculem els coeficients de les corbes de Bezier de tercer
c     grau tant per energia (ee) com per la potencia (pp), com per
c     la derivada de potencia respecte hd (dphd), com per la derivada
c     de energia respecte hd (dehd)
      
      ee(2)= 3.0*(e(2)-e(1))
      ee(3)= 3.0*(e(3)-2.0*e(2)+e(1))
      ee(4)= e(4)-3.0*e(3)+3.0*e(2)-e(1)
      
      pp(1)= p(1)
      pp(2)= 3.0*(p(2)-p(1))
      pp(3)= 3.0*(p(3)-2.0*p(2)+p(1))
      pp(4)= p(4)-3.0*p(3)+3.0*p(2)-p(1)
         
      dehd(1)= ehd(1)
      dehd(2)= 3.0*(ehd(2)-ehd(1))
      dehd(3)= 3.0*(ehd(3)-2.0*ehd(2)+ehd(1))
      dehd(4)= ehd(4)-3.0*ehd(3)+3.0*ehd(2)-ehd(1)
      
      dphd(1)= phd(1)
      dphd(2)= 3.0*(phd(2)-phd(1))
      dphd(3)= 3.0*(phd(3)-2.0*phd(2)+phd(1))
      dphd(4)= phd(4)-3.0*phd(3)+3.0*phd(2)-phd(1)         
      
      depg(1)= epg(1)
      depg(2)= 3.0*(epg(2)-epg(1))
      depg(3)= 3.0*(epg(3)-2.0*epg(2)+epg(1))
      depg(4)= epg(4)-3.0*epg(3)+3.0*epg(2)-epg(1)
      
      dppg(1)= ppg(1)
      dppg(2)= 3.0*(ppg(2)-ppg(1))
      dppg(3)= 3.0*(ppg(3)-2.0*ppg(2)+ppg(1))
      dppg(4)= ppg(4)-3.0*ppg(3)+3.0*ppg(2)-ppg(1)         

      end 


c***********************************************************************
c     computing values of cpe, and derivatives parcialgen, parcialhd
c***********************************************************************
      subroutine eval_cpe(gen,cpe,parcialgen,parcialhd,parcialpg)
      implicit none
      include 'htcoor_f.h'
c     parametres 
      real*8 gen,cpe,parcialgen,parcialhd,parcialpg
c     variables locals
      integer*4 k,narrels
      real*8 tt,arrels(3),auxdpdt,auxdpdhd,auxdtde,auxdedhd,pendent,
     $     aux,aux1,auxdpdpg,auxdedpg
      
c     calculem la funcon i derivades depenent del valor de gen tenim
c     tres parts de la funcon.

c     cas 1: estem a corba de Bezier
      if ((gen.gt.e(1)).and.(gen.lt.e(4))) then 
         ee(1)= e(1)-gen
c     trobem la tt que fa que ee(tt)=gen.
         call pa03ad(ee,arrels,narrels)
         if (narrels.eq.1) then
            tt= arrels(1)
         else !narrels=3
            k=1
            do while(.not.(arrels(k).ge.0.0).and.(arrels(k).
     $           le.1.0))
               k= k+1
               if (k.gt.3) STOP 'EVAL_CPE: t INCORRECTA '
            end do
            tt= arrels(k)
         end if
c     calcul de p(e)
         cpe= pp(1)+tt*(pp(2)+tt*(pp(3)+tt*pp(4)))
c     calcul de les parcials de dp/de i dp/dhdk
         auxdpdt= pp(2)+tt*(2.0*pp(3)+tt*3.0*pp(4))
c**         if (dabs(ee(2)+tt*(2.0*ee(3)+tt*3.0*ee(4))).lt.1.0d-6) stop '9'
         auxdtde= 1.0d0/(ee(2)+tt*(2.0*ee(3)+tt*3.0*ee(4)))
         parcialgen= auxdpdt*auxdtde
         auxdpdhd=dphd(1)+tt*(dphd(2)+tt*(dphd(3)+
     $        tt*dphd(4)))
         auxdedhd=dehd(1)+tt*(dehd(2)+tt*(dehd(3)+
     $        tt*dehd(4)))
         parcialhd=auxdpdhd-auxdpdt*auxdtde*auxdedhd 
         auxdpdpg=dppg(1)+tt*(dppg(2)+tt*(dppg(3)+tt*dppg(4)))
         auxdedpg=depg(1)+tt*(depg(2)+tt*(depg(3)+tt*depg(4)))         
         parcialpg= auxdpdpg-auxdpdt*auxdtde*auxdedpg

c     cas 2: pertany a part lineal inicial. La relacio es e=p*Tb
      else  if (gen.le.e(1)) then
         cpe= gen*p(1)/e(1)
         parcialgen= p(1)/e(1)
         parcialhd= 0.0d0
         parcialpg= 0.0d0

c     cas 3: pertany a part lineal final
      else 
         if (dabs(e(4)-e(3)).lt.1.0d-20) then
            write(*,*) e(4),e(3)
            write(*,*) p(4),p(3)
c**            stop'10'
         end if
         pendent= (p(4)-p(3))/(e(4)-e(3))
         cpe= pendent*(gen-e(3))+p(3)
         parcialgen= pendent
         aux= e(4)-e(3)
         aux1=(phd(4)-phd(3))*aux-(ehd(4)-ehd(3))*(p(4)-p(3))
         aux1= aux1/(aux*aux)
         parcialhd= aux1*(gen-e(3))-pendent*ehd(3)+phd(3)
         aux1= (ppg(4)-ppg(3))*aux-(epg(4)-epg(3))*(p(4)-p(3))
         aux1= aux1/(aux*aux)
         parcialpg= aux1*(gen-e(3))-pendent*epg(3)+ppg(3)
      endif                
      end 

c***********************************************************************
c     Harwell routine to compute roots of third degree polynomial
c***********************************************************************
c/     add name=pa03ad          hsl     f77     double
*######date 15 mar 1990     copyright ukaea, harwell.
c######alias pa03ad
c######calls fd05
      subroutine pa03ad(aa,r,n)
c**************************************************************
c*  purpose....                                               *
c*  to find the roots of the real cubic ......                *
c*          a(4)*x**3+a(3)*x**2+a(2)*x+a(1)                   *
c*                                                            *
c*  argument list....                                         *
c*  aa  is a real array of length 4 which will contain the    *
c*      coefficients a.                                       *
c*  r   is a real array which will have its components        *
c*      set to the roots.if there are three real roots,then   *
c*      r(1).le.r(2).le.r(3). for one real root,r(1) is set   *
c*      to it,r(2) is set to the real part of both complex    *
c*      roots and r(3) is set to the imaginary part which is  *
c*      is positive.the dummy value of 1d+70 is returned for  *
c*      each infinite root.this corresponds to a zero         *
c*      leading coefficient.                                  *
c*  n   is an integer whose value will be set by the routine  *
c*      to the number of real roots.                          *
c**************************************************************
      implicit none
      real*8 c1,c5,c3,c0,c4,c23,xinf,a,r,b,aa,ta,tb,tc,
     $  te,tf,x,y,z,fd05ad
      integer*4 n
      dimension a(3),r(3),b(2),aa(4)
      data   c1/1.d0/,c5/.5d0/,c3/3.d0/,c0/0.d0/,c4/4.d0/
      data   c23/0.666666666666666667d0/
c     data   xinf/1.d+70/
c
c     is leading coefficient zero,ie infinite root.
      xinf=fd05ad(5)*.1d0
      if(aa(4).eq.c0)go to 80
      if(aa(1).eq.c0)go to 70
      a(3)=aa(3)/(c3*aa(4))
      a(2)=aa(2)/(c3*aa(4))
      a(1)=aa(1)/aa(4)
      x=a(2)-a(3)*a(3)
      y=a(1)-a(3)*(x+x+a(2))
      z=y**2+c4*x**3
      if(z.ge.c0)goto100
c
c     there are three real roots.
      n=3
      r(1)=-2.0d0*dsqrt(-x)
      y=y/(r(1)*x)
      x=r(1)
      y =datan2(dsqrt(c1-y),dsqrt(c1+y))*c23
      if(a(3).lt.c0)y=y+2.094395102393195d0
c
c     calculate root which does not involve cancellation
      r(1)=x*dcos(y)-a(3)
c
c     deflate cubic from optimal end.
   10 b(1)=-a(1)/r(1)
      b(2)=(b(1)-c3*a(2))/r(1)
      if(dabs(r(1)**3).le.dabs(a(1)))b(2)=r(1)+c3*a(3)
   20 x=b(2)*b(2)-c4*b(1)
c
c     is the pair of roots real or complex.
      if(x.lt.c0)goto 60
      r(3)=-dsign(c5,b(2))*(dsqrt(x)+dabs(b(2)))
      r(2)=c0
      if(r(3).ne.c0)r(2)=b(1)/r(3)
      if(r(1).le.r(2))go to 30
      ta=r(2)
      r(2)=r(1)
      r(1)=ta
   30 if(r(2).le.r(3))go to 50
      ta=r(3)
      if(r(1).le.r(3))go to 40
      ta=r(1)
      r(1)=r(3)
   40 r(3)=r(2)
      r(2)=ta
   50 n=3
      go to 150
   60 r(2)=-c5*b(2)
      r(3)=c5*dsqrt(-x)
      n=1
      go to 150
   70 r(1)=c0
      b(1)=aa(2)/aa(4)
      b(2)=aa(3)/aa(4)
      go to 20
c
c     the cubic has leading coefficient zero,ie quadratic
   80 r(1)=xinf
      if(aa(3).eq.c0)go to 90
      b(1)=aa(1)/aa(3)
      b(2)=aa(2)/aa(3)
      go to 20
c
c     cubic has first two leading coefficients zero
   90 if(aa(2).ne.c0)r(1)=-aa(1)/aa(2)
      r(2)=xinf
      r(3)=xinf
      n=3
      go to 150
c
c     there is one real root.
  100 n=1
      ta=dsqrt(z)
      tb=(dabs(y)+ta)*c5
      tc=tb**0.333333333333333333d0
      if(tc.gt.0.0d0)go to 110
      r(1)=-a(3)
      r(2)=-a(3)
      r(3)=-a(3)
      n=3
      go to 150
  110 tc=tc-(tc**3-tb)/(c3*tc*tc)
      te=tc*tc+dabs(x)
      tf=c1/((x/tc)**2+te)
      if(x.lt.c0)goto120
      x=te/tc
      z=y*tf
      goto130
  120 x=ta*tf
      z=dsign(c1,y)*te/tc
  130 if(z*a(3).lt.c0)goto140
      r(1)=-z-a(3)
      go to 10
  140 r(2)=c5*z-a(3)
      r(3)=c5*dsqrt(c3)*dabs(x)
      r(1)=-a(1)/(r(2)*r(2)+r(3)*r(3))
  150 return
      end
      real*8 function fd05ad( inum )
      implicit none
      integer*4 inum
      real*8 dc( 5 )
c
c  real constants (double precision arithmetic).
c
c  obtained from h.s.l. subroutine ze02am.
c  nick gould and sid marlow, harwell, july 1988.
c
c  dc(1) the smallest positive number: 1.0 + dc(1) > 1.0.
c  dc(2) the smallest positive number: 1.0 - dc(2) < 1.0.
c  dc(3) the smallest nonzero +ve real number.
c  dc(4) the smallest full precision +ve real number.
c  dc(5) the largest finite +ve real number.
c
      data dc( 1 ) /    0.222044604925031309d-15 /
      data dc( 2 ) /    0.138777878078144569d-16 /
      data dc( 3 ) /    0.539760534693402790d-78 /
      data dc( 4 ) /    0.539760534693402790d-78 /
      data dc( 5 ) /    0.723700557733226210d+76 /
c      if ( inum .le. 0 .or. inum .ge. 6 ) then
c         print 2000, inum
c         stop
c      else
         fd05ad = dc( inum )
c      endif
      return
 2000 format( ' inum =', i3, ' out of range in fd05ad.',
     $        ' execution terminated.' )
      end


