
	SUBROUTINE CALCULO_FILAS(monotona, potes)

	IMPLICIT NONE

	INCLUDE 'mono.h'
	RECORD /MON_CARGA/ MONOTONA
        INTEGER POTES(*)              ! la monotona en cuestion, expresada
                                      ! en potencia / franja de tiempo
	LOGICAL pminzero

	INTEGER  COL, K, J, COL_1

	pminzero = .TRUE.
	COL_1 = MONOTONA.NQP
	COL = 0
	K = MONOTONA.NQT+1
	J = 1
	DO WHILE (J .LE. COL_1)
	     K = K-1
	     DO WHILE (POTES(K) .EQ. COL)
		K = K-1
	     ENDDO
	     COL = POTES(K)
	     DO WHILE (J .LE. COL)
		MONOTONA.FILAS(J) = K
		J = J+1
	     ENDDO
	     IF (pminzero) THEN
		pminzero = .FALSE.
		MONOTONA.PMIN = J-1
	     END IF
	ENDDO

	END	

C	-.,-.,-.,-.,-.,-.,-.,-.,-.,-.,-.,-.,-.,-.,-.,-.,-.,-.,-.,-.,-.,-.,-.,
C	devuelve cierto en el caso que no se pueda alcanzar la energia pedida
C	-.,-.,-.,-.,-.,-.,-.,-.,-.,-.,-.,-.,-.,-.,-.,-.,-.,-.,-.,-.,-.,-.,-.,

	LOGICAL FUNCTION MONOTONA_2(MON_1,MON_2,E)

	IMPLICIT NONE
	INCLUDE 'mono.h'

	RECORD /MON_CARGA/ MON_1, MON_2
	INTEGER  E
	INTEGER  SUMA, J, ALTURA_MONO
	LOGICAL  FIN, LIMITE

	FIN = .FALSE.
	LIMITE = .FALSE.
	SUMA = 0
	J = MON_1.NQP
	DO WHILE (J .GT. MON_1.NQP - MON_1.NP    .AND. 
     >		  SUMA + MON_1.FILAS(J) .LE. E)
	     SUMA = SUMA + MON_1.FILAS(J)
	     MON_2.FILAS(J) = 0
	     J=J-1
	ENDDO

	IF (SUMA + MON_1.FILAS(J) .LE. E) THEN	        ! /*  J <= ny - np  */
	     DO WHILE (.NOT. FIN .AND. J .GT. 1)
		SUMA = SUMA + MON_1.FILAS(J) - MON_1.FILAS(J+MON_1.NP)
		MON_2.FILAS(J) = MON_1.FILAS(J+MON_1.NP)
		J=J-1
		FIN = (SUMA + MON_1.FILAS(J) - MON_1.FILAS(J+MON_1.NP))
     >			 .GT. E
	     ENDDO

	     IF (.NOT. FIN) THEN		!    J = 1
		SUMA = SUMA + MON_1.FILAS(J) - MON_1.FILAS(J+MON_1.NP)
					    	! ltima suma, con lo que no
		LIMITE = .TRUE.                 ! llega a E, ni llegaremos.
	     ENDIF
	ENDIF
        MON_2.FILAS(J) = SUMA - E + MON_1.FILAS(J)

	MON_2.PMIN = 0
	DO WHILE (J.GT. 1)
	     J=J-1
	     MON_2.FILAS(J) = Mon_1.Filas(J)
	     IF (MON_2.PMIN .EQ. 0 .AND. MON_2.FILAS(J) .EQ. MON_1.NQT)
     >		 MON_2.PMIN = J
	ENDDO

	MON_2.NQT = MON_1.NQT
	MON_2.NQP = ALTURA_MONO(MON_2)
	MONOTONA_2 = LIMITE
	END	
c       ..............................................................
        LOGICAL FUNCTION MONOTONA_3(MON_1,MON_2,E,NB,TECHO)
        implicit none
!
!       Para bombear una cantidad "e" en cuadritos, con una limitacion en
!       potencia de "nb" cuadritos y un techo a no rebasar en la fila "techo"
!
	INCLUDE 'mono.h'

	RECORD /MON_CARGA/ MON_1, MON_2
	INTEGER  E, NB, TECHO
        integer  j, b, c
        logical  fin

        b=e
        j=1
        do while (mon_1.filas(j) .eq. mon_1.filas(j+1))
            mon_2.filas(j) = mon_1.filas(j)
            j=j+1
        end do
        mon_2.filas(j) = mon_1.filas(j)

        fin = .false.
        j=j+1
        do while (.not. fin)
            c = min(mon_1.filas(j-nb) - mon_1.filas(j),
     >          mon_1.nqt - mon_1.filas(j), b)
            b=b-c
            mon_2.filas(j) = mon_1.filas(j) + c
            j=j+1
            if (b .eq. 0 .or. j .eq. techo) fin = .true.
        end do

        do while (j .le. mon_1.nqp)
            mon_2.filas(j) = mon_1.filas(j)
            j=j+1
        end do

        mon_2.nqp = mon_1.nqp
        mon_2.nqt = mon_1.nqt
        mon_2.np = mon_1.np
!        mon_2.m = mon_1.m

        monotona_3 = (b .ne. 0)
	if (b.ne.0) e=e-b

        end

C	:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

	INTEGER FUNCTION ALTURA_MONO(MONOTONA)

	IMPLICIT NONE
	INCLUDE 'mono.h'

	RECORD /MON_CARGA/ MONOTONA
	INTEGER NY

	NY = 0
	DO WHILE (MONOTONA.FILAS(NY+1) .GT. 0)
		NY=NY+1
	ENDDO
	ALTURA_MONO = NY
	RETURN
	END

C	::::::::::::::::::::::::::::::::::::::::

	REAL *8 FUNCTION INTEGRAL_DISCR(X,MONOTONA,ESCALAS)

	IMPLICIT NONE
	INCLUDE 'mono.h'

	RECORD /MON_CARGA/ MONOTONA
	RECORD /INCRES/ ESCALAS
	REAL *8 X, l
        INTEGER area, i, filsup
	
        area = 0
	l = X/ESCALAS.INC_P
        filsup = int(l)		!! Fila superior, limite de integracion
	DO i=1,filsup
		area=area+MONOTONA.FILAS(i)
	ENDDO
	area = area + int( (l-filsup)*MONOTONA.FILAS(filsup+1) )

	INTEGRAL_DISCR = area*ESCALAS.INC_E
	RETURN

	END

C	::::::::::::::::::::::::::::::::::::::::

	REAL *8 FUNCTION INTEGRAL_SEMI_DISCR(A,B,MONOTONA,ESCALAS)

	IMPLICIT NONE				! Integral de una monotona
	INCLUDE 'mono.h'			! REAL, entre a y b

	RECORD /MON_CARGA_R/ MONOTONA
	RECORD /INCRES/ ESCALAS
	REAL *8 a, b, lup, ldwn, area
        INTEGER i, filsup, filinf
	
        area = 0.d0
	lup = b/ESCALAS.INC_P
	ldwn = a/ESCALAS.INC_P
        filsup = int(lup)		!! Fila superior, limite de integracion
					!! anhadir un trocito por arriba
        filinf = int(ldwn)+1		!! Fila inferior, limite de integracion
					!! quitar un trocito por debajo
	DO i=filinf, filsup
		area=area+MONOTONA.FILAS(i)
	ENDDO
	area = area + (lup-filsup)*MONOTONA.FILAS(filsup+1) 
     >              - (ldwn+1.d0-filinf)*MONOTONA.FILAS(filinf)

	INTEGRAL_SEMI_DISCR = area*ESCALAS.INC_E
	RETURN

	END

C	::::::::::::::::::::::::::::::::::::::::

	REAL *8 FUNCTION CONTRAINTEGRAR(X,MONOTONA,ESCALAS)

	IMPLICIT NONE
	INCLUDE 'mono.h'

	RECORD /MON_CARGA/ MONOTONA
	RECORD /INCRES/ ESCALAS
	REAL *8 X, Y, CARGA
        INTEGER altura, i
	
        altura = 0
	y = X/ESCALAS.INC_E
	i = 0
	DO WHILE ( i .lt. monotona.nqp  .and.
     >		   altura + monotona.filas(i+1) .lt. y)
		i = i+1
		altura = altura + MONOTONA.FILAS(i)
	ENDDO
	if (i .lt. monotona.nqp) then
	    carga = i*ESCALAS.INC_P 
     >          + (y-altura)/MONOTONA.FILAS(i+1)*ESCALAS.INC_P
	else
	    carga = i*ESCALAS.INC_P
	end if

	CONTRAINTEGRAR = carga
	RETURN

	END

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
        INTEGER FUNCTION MONO_DIFERIR(m1, m2, nb, rel, paso)
        implicit none
        include 'mono.h'
        
        record /mon_carga/ m1,m2
        integer i,nb,paso            ! +1: abajo->arriba; -1: arriba->abajo
        integer ancho_banda
	real *8 rel

        if (paso .eq. 1) then				! caso descrestar
             i=1
             do while ( m1.filas(i) .eq. m2.filas(i) .and.
     >                   i .le. m1.nqp )
                i=i+1
             end do
             if (i.le.m1.nqp) then
                rel=dble(ancho_banda(m1,m2,i))/ancho_banda(m1,m1,i)
	     else
		rel = 0.d0
	     end if
        else						! caso bombear
             i=m1.nqp
             do while ( m1.filas(i) .eq. m2.filas(i) .and.
     >                   i .ge. 1 )
                i=i-1
             end do
             if (i.ge.nb) rel = dble(m2.filas(i)-m1.filas(i))
     >          /(min(m2.filas(i-nb),m2.nqt)-m1.filas(i))
        end if
        mono_diferir = i

        end

c/ / / / / / / / / / / / / / / / / / / / / / / / / / / / / 

        REAL *8 FUNCTION HD_ALBORDE(monotona,escalas,p)
        implicit none

        include 'mono.h'

        record /mon_carga/ monotona
        record /incres/ escalas
        real *8 p, ipp
        integer f, hh, i, ancho_banda

        ipp = p/escalas.inc_p
        f = int(ipp+0.999)				! parte entera por exceso
        hh = int((f-ipp)*ancho_banda(monotona,monotona,f-1) + 0.5)
        do i=f, monotona.nqp
           hh = hh+ancho_banda(monotona,monotona,i)
        end do

        hd_alborde = dble(hh*escalas.inc_e)

        end

c/ / / / / / / / / / / / / / / / / / / / / / / / / / / 

	INTEGER FUNCTION ANCHO_BANDA(m0,m_des,f)
        implicit none

        include 'mono.h'

        record /mon_carga/ m0,m_des
	integer f,y

        if (f+m0.np .gt. m0.nqp) then
              y = 0
           else
              y = m0.filas(f+m0.np)
        end if   
        ancho_banda = m_des.filas(f) - y

	end
cccccccccccc////////////////////////////////////////

	REAL *8 FUNCTION TIEMPO_MONO(mono,escalas,pote)
	implicit none

        include 'mono.h'

        record /mon_carga/ mono
        record /incres/ escalas
	real *8 pote, ipp, frac
	integer i

        ipp = pote/escalas.inc_p
        i = int(ipp)		
	frac = ipp - i
	tiempo_mono = (frac*mono.filas(i+1) + (1.d0-frac)*mono.filas(i))
     >			*escalas.inc_t

	end
cxcxcxcxcxcxcxcxcxcxcxcxcxcxcxcxcxcxcxcxcxcxcxcxcxcxcxcxcxcxcxcxcxcxc

        REAL *8 FUNCTION POT_TERMICA(en_hd, esc, monotona, mon2, Fin)
        IMPLICIT NONE

	INCLUDE 'mono.h'			!!    O J O  !!
						!!  en_hd es `entero'
	record /mon_carga/ monotona,mon2
	record /incres/ esc			    
        real *8 en_hd
	integer sup
        LOGICAL fin, MONOTONA_2

	sup = int(en_hd/esc.inc_e + 0.5)
	fin = MONOTONA_2(monotona, mon2, sup)
	Pot_Termica = mon2.nqp*esc.inc_p
        end

czczczczczczczczczczczczczczczczczczczcczczczczczczcczczczczczczczczc
c	Una funcion para calcular la media de potencia que ocuparia
c	una cantidad de energia H que no se sabe donde esta colocada 
c	en la monotona (semi-discreta).
	REAL *8 FUNCTION POTENCIA_ALEATORIA(H, ESC, MONO)
        IMPLICIT NONE

	INCLUDE 'mono.h'		
						
	record /mon_carga_r/ mono 
	record /incres/ esc			    
        real *8 h
	real *8 en_equiv, p, p_acum
	integer m
	logical fin

	en_equiv = h/esc.inc_e		! "cuadritos"
	p_acum = 0.d0
	m = 0
	fin = .false.
	do while (.not. fin)
		call encajar_enrg(mono, en_equiv, m, p, fin)
		if (.not. fin) then
			m = m+1
			p_acum = p_acum + p*esc.inc_p
		else
			potencia_aleatoria = p_acum/m
		end if
	end do
	return
	end

	subroutine encajar_enrg(mono, e, m, p, fin)
	implicit none
	include 'mono.h'

	record /mon_carga_r/ mono 
	real *8 e, p, e2
	integer m, i
	logical fin

	e2 = e
	i = m+1
	do while (mono.filas(i) .lt. e2 .and. i .lt. mono.nqp)
		e2 = e2 - mono.filas(i)
		i = i + 1
	end do
	if (mono.filas(i) .ge. e2) then
		p = i - m-1 + e2/mono.filas(i)
		fin = .false.
	else
		fin = .true.
	end if
	end
