c***********************************************************************
c     rutina per concatenar els strings str2 i str3 i deixar-ho en str1
c     es suposa que l'string finalitza amb el primer ' ' (si no existeix
c     l'string es tota la variable) a partir
c     d'on es concatena. str1 pot ser str2 o str3 sense cap problema.
c***********************************************************************
      subroutine concat(str1,str2,str3)
      character*(*) str1,str2,str3
      integer n
      
      n= index(str2,' ')
      if (n.eq.0) then
         str1= str2//str3
      else
         str1= str2(1:n-1)//str3
      end if
      end
      
c***********************************************************************
c     rutina per transformar un enter en string
c     n es l'enter;s es l'string;l el total de caracters a escriure a s
c***********************************************************************
	subroutine itostr(n,s,l)
	integer n,l
	character*(*) s

	integer i,digit,zero,auxn
	
        s=' '
	auxn= n
	zero= ichar('0')
	do i=1,l
		digit= mod(auxn,10)
		auxn= auxn/10
		s(l-i+1:l-i+1)= char(digit+zero)	
	end do
	end

c***********************************************************************
c     rutina per passar strin tot a majuscules i deixar-ho en strout
c     es suposa que strin finalitza amb un blanc ' ' (i si no hi ha
c     cap blanc, es pasara tot l'string a majuscules) strin i strout
c     poden ser els mateixos.
c***********************************************************************
      subroutine majuscules(strin,strout)
      implicit none
      character*(*) strin,strout
      integer n
      character c
      integer i,j
      n= index(strin,' ')-1
      if (n.lt.0) n= len(strin)
      do i=1,n
         c= strin(i:i)
         j=ichar(c)
         if ((j.ge.97).and.(j.le.122)) c= char(j-32)
         strout(i:i)= c
      end do
      do j= n+1,len(strout)
         strout(j:j)= ' '
      end do
      end
      
c***********************************************************************
c     rutina per passar strin tot a minuscules i deixar-ho en strout
c     es suposa que strin finalitza amb un blanc ' ' (i si no hi ha
c     cap blanc, es pasara tot l'string a minuscules) strini strout
c     poden ser els mateixos.
c***********************************************************************
      subroutine minuscules(strin,strout)
      implicit none
      character*(*) strin,strout
      integer n
      character c
      integer i,j
      n= index(strin,' ')-1
      if (n.lt.0) n= len(strin)
      do i=1,n
         c= strin(i:i)
         j=ichar(c)
         if ((j.ge.65).and.(j.le.90)) c= char(j+32)
         strout(i:i)= c
      end do
      do j= n+1,len(strout)
         strout(j:j)= ' '
      end do
      end
      
c***********************************************************************
c     rutina per buscar un string str dins un array de strings astr de
c     dimensio n
c***********************************************************************
      integer function busca_str(astr,n,str)
      implicit none
      integer n
      character*(*) astr(n),str
      integer i
      logical trobat
      
      i=1
      trobat= .false.
      do while ((.not.trobat).and.(i.le.n))
         if (str.eq.astr(i)) then
            trobat= .true.
         else
            i=i+1
         endif
      end do
      if (trobat) then
         busca_str= i
      else
         busca_str= -1
      endif
      end
      

c***********************************************************************
c     rutina per retornar el prefix de strin que nomes conte
c     lletres (majuscules o minuscules). el prefix es retorna per
c     strout. strin i strout poden ser la mateixa variable. es suposa
c     que strin finalitza amb el primer blanc ' ' que trobem (i si no
c     n'hi ha cap es considera tot l'string)
c***********************************************************************
      subroutine prefix(strin,strout)
      implicit none
      character*(*) strin,strout
      integer n
      character c
      integer i,j
      n= index(strin,' ')-1
      if (n.lt.0) n=len(strin)
      do i=1,n
         c= strin(i:i)
         j=ichar(c)
         if ((j.lt.65).or.(j.gt.122).or.((j.gt.90).and.(j.lt.97))) 
     +        then
            do j= i,len(strout)
               strout(j:j)= ' '
            end do
            return
         end if
         strout(i:i)= c
      end do
      do j= n+1,len(strout)
         strout(j:j)= ' '
      end do
      end
      

