ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c	RUTINAS para ajustes con restricciones sobre los limites 
c	de las variables

	SUBROUTINE AJUSTE_CONLIM(XN, PROB, TIPO, MAXOBS)
	implicit none

	integer    prob, tipo, MAXOBS
	real *8    xn(*), BIG
	parameter (BIG = 1.d20)

	integer varH, varY
	common /hasta/ varH, varY
	common /m1file/ iread, iprint, isumm
	integer iread, iprint, isumm

	integer	   mm, n, nb, ne, nncon, nnobj, nnjac, dummy, inform,
     >		   mincor, ns, ninf, nwcore, iobj, iaux
	parameter (nwcore=4000)
	integer	   ka(4), ha(3), hs(4)
	real*8	   sinf, obj, objadd
	real*8	   aa(3), bl(4), bu(4), pi(1), rc(4), z(nwcore)
	character*8	names(5)
C
C	tipo = 1 <--> solo varia la H (no hay contratos ni unidades limitadas);
C		      tambien varia la Y, pero solo es parte hidro.
C	tipo = 2 <--> solo varia la Y (no hay hidraulica)
C	tipo = 3 <--> varian las dos magnitudes (full problem)
C
	varH = MAXOBS
	varY = MAXOBS
	if (tipo.eq.2) varH = 1

	names(1) = 'problem '
	names(2) = 'lin.obj.'
	names(3) = 'rhs     '
	names(4) = 'ranges  '
	names(5) = 'bounds  '

	mm = 1
	n = 3
	nb = n+mm
	nncon = 0
	nnobj = n
	nnjac = 0
	ne = 3
	
c	l i m i t e s   p a r a   l a s   v a r i a b l e s
	bl(1) = 1.d-4			!!
	bu(1) = BIG			!!   a > 0
	bl(2) = -100			!!
	bu(2) = -1.d-4			!!   b < 0
	if (prob .eq. 1) then
		bl(3) = 0.d0		!!   c >= 0
	else
		bl(3) = 1.d-3		!!   c > 0  (time must be non-zero)
	end if
	bu(3) = BIG

	xn(1) = 3.0
	xn(2) = -3.0
	xn(3) = 0.1

	iread = 0
	iprint = 0
	isumm = 0
	call mispec(iread, iprint, isumm, nwcore, inform)
	call miopt('Defaults', iprint, isumm, inform)
	if (tipo.ne.1) then
	    call miopt('Problem number 1001', iprint, isumm, inform)
	else
	    call miopt('Problem number 1002', iprint, isumm, inform)
	end if

	iaux= 1
	iobj= 1
	objadd= 0.0d0
	call minoss( 'Cold', mm, n, nb, ne, iaux, nncon, nnobj, nnjac,
     >		    iobj, objadd, names, aa, ha, ka, bl, bu, dummy,
     >		    dummy, hs, xn, pi, rc, inform, mincor, ns, 
     >		    ninf, sinf, obj, z, nwcore )

	end

ccccccccccccccccccccccccccccccccccccccccccc___("Tipo" = 2, 3)____cccc
	subroutine fun11(n,x,fvec,fjac)
	implicit none

	include 'constbez.h'

	integer n, i, j 
	real *8 x(n), fvec, fjac(n)

	real *8 hd(MAXOBS), y(MAXOBS,MAXOBS), tmp(MAXOBS,MAXOBS),
     >		trm(MAXOBS)
	integer prob
	common /sitio/ hd, trm, y, tmp, prob
	real *8 tt(MAXOBS), zonaX, aux, aux2, z, sgn
	integer varH, varY
	common /hasta/ varH, varY
	parameter (zonaX = 0.001)
	logical escri
	data escri/.true./

	fvec = 0.d0
	do i = 1, n
		fjac(i) = 0.d0
	end do
	do j = 1, varY
		tt(j) = trm(j) * trm(j)
	end do
	do i = 1, varH
	    do j = 1, varY
		aux = tt(j)/(hd(i)-x(2))
		z = x(1)*aux + x(3)
	    	if (prob .eq. 1) then
			z = z - y(i,j)
	    	else
			z = z - tmp(i,j)
	    	end if
		if (abs(z) .gt. zonaX) then
		    fvec = fvec + abs(z)
		    sgn = 1.0
		    if (z.lt.0.0) sgn = -1.0
		    fjac(1) = fjac(1) + sgn*aux
		    fjac(2) = fjac(2) + sgn*x(1)*aux/(hd(i)-x(2))
		    fjac(3) = fjac(3) + sgn
		else
		    aux2 = z/zonaX
		    fvec = fvec + 0.5*z*aux2 + 0.5*zonaX
		    fjac(1) = fjac(1) + aux2*aux
		    fjac(2) = fjac(2) + aux2*x(1)*aux/(hd(i)-x(2))
		    fjac(3) = fjac(3) + aux2
		end if
	    end do
	end do

	escri= .false.
	if (escri) then
	   do i=1, varH
	      do j=1, varY
		write(8,*) hd(i), trm(j), y(i,j)
	      end do
	   end do
	   escri = .false.
	end if
	end
cccccccccccccccccccccccccccccccccccccccccccc___("Tipo" = 1)____ccccc
	subroutine fun12(n,x,fvec,fjac)
	implicit none

	include 'constbez.h'

	integer n, i, j 
	real *8 x(n), fvec, fjac(n)

	real *8 hd(MAXOBS), y(MAXOBS,MAXOBS), tmp(MAXOBS,MAXOBS),
     >		trm(MAXOBS)
	integer prob
	common /sitio/ hd, trm, y, tmp, prob
	real *8 tt(MAXOBS), zonaX, aux, aux2, z, sgn
	integer varH, varY
	common /hasta/ varH, varY
	real*8	palea(MAXOBS)
	common /hasta2/ palea
	parameter (zonaX = 0.001)
	logical	saca

	saca = .false.
	fvec = 0.d0
	do i = 1, n
		fjac(i) = 0.d0
	end do
	do j = 1, varY
		tt(j) = trm(j) * trm(j)
	end do
	do i = 1, varH
	    j = 1
	    do while (j.le.varY .and. trm(j).le.palea(i))
		aux = tt(j)/(hd(i)-x(2))
		z = x(1)*aux + x(3)
	    	if (prob .eq. 1) then
			z = z - y(i,j)
			if (saca)
     >   write(*,*) i, j, hd(i), trm(j), y(i,j)
	    	else
			z = z - tmp(i,j)
			if (saca)
     >   write(*,*) i, j, hd(i), trm(j), tmp(i,j)
	    	end if
		if (abs(z) .gt. zonaX) then
		    fvec = fvec + abs(z)
		    sgn = 1.0
		    if (z.lt.0.0) sgn = -1.0
		    fjac(1) = fjac(1) + sgn*aux
		    fjac(2) = fjac(2) + sgn*x(1)*aux/(hd(i)-x(2))
		    fjac(3) = fjac(3) + sgn
		else
		    aux2 = z/zonaX
		    fvec = fvec + 0.5*z*aux2 + 0.5*zonaX
		    fjac(1) = fjac(1) + aux2*aux
		    fjac(2) = fjac(2) + aux2*x(1)*aux/(hd(i)-x(2))
		    fjac(3) = fjac(3) + aux2
		end if
		j = j+1
	    end do
	end do
	end



